MinGW: Use pid_t more consequently, introduce uid_t for greater compatibility
[git/dscho.git] / t / test-lib.sh
blob9263614017e6d21d14ae665a7658c704f3093f6a
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
92 esac
94 # Convenience
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
114 color=t
116 while test "$#" -ne 0
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
126 help=t; shift ;;
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
129 -q|--q|--qu|--qui|--quie|--quiet)
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133 --with-dashes)
134 with_dashes=t; shift ;;
135 --no-color)
136 color=; shift ;;
137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138 valgrind=t; verbose=t; shift ;;
139 --tee)
140 shift ;; # was handled already
141 --root=*)
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143 shift ;;
145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146 esac
147 done
149 if test -n "$color"; then
150 say_color () {
152 TERM=$ORIGINAL_TERM
153 export TERM
154 case "$1" in
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
159 *) test -n "$quiet" && return;;
160 esac
161 shift
162 printf "%s" "$*"
163 tput sgr0
164 echo
167 else
168 say_color() {
169 test -z "$1" && test -n "$quiet" && return
170 shift
171 echo "$*"
175 error () {
176 say_color error "error: $*"
177 GIT_EXIT_OK=t
178 exit 1
181 say () {
182 say_color info "$*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
189 then
190 echo "$test_description"
191 exit 0
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197 exec 4>&2 3>&1
198 else
199 exec 4>/dev/null 3>/dev/null
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
208 test_external_has_tap=0
210 die () {
211 code=$?
212 if test -n "$GIT_EXIT_OK"
213 then
214 exit $code
215 else
216 echo >&5 "FATAL: Unexpected exit with code $code"
217 exit 1
221 GIT_EXIT_OK=
222 trap 'die' EXIT
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234 FAKE_EDITOR="$1"
235 export FAKE_EDITOR
236 EDITOR='"$FAKE_EDITOR"'
237 export EDITOR
240 test_decode_color () {
241 sed -e 's/.\[1m/<WHITE>/g' \
242 -e 's/.\[31m/<RED>/g' \
243 -e 's/.\[32m/<GREEN>/g' \
244 -e 's/.\[33m/<YELLOW>/g' \
245 -e 's/.\[34m/<BLUE>/g' \
246 -e 's/.\[35m/<MAGENTA>/g' \
247 -e 's/.\[36m/<CYAN>/g' \
248 -e 's/.\[m/<RESET>/g'
251 q_to_nul () {
252 perl -pe 'y/Q/\000/'
255 q_to_cr () {
256 tr Q '\015'
259 q_to_tab () {
260 tr Q '\011'
263 append_cr () {
264 sed -e 's/$/Q/' | tr Q '\015'
267 remove_cr () {
268 tr '\015' Q | sed -e 's/Q$//'
271 test_tick () {
272 if test -z "${test_tick+set}"
273 then
274 test_tick=1112911993
275 else
276 test_tick=$(($test_tick + 60))
278 GIT_COMMITTER_DATE="$test_tick -0700"
279 GIT_AUTHOR_DATE="$test_tick -0700"
280 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
283 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
285 # This will commit a file with the given contents and the given commit
286 # message. It will also add a tag with <message> as name.
288 # Both <file> and <contents> default to <message>.
290 test_commit () {
291 file=${2:-"$1.t"}
292 echo "${3-$1}" > "$file" &&
293 git add "$file" &&
294 test_tick &&
295 git commit -m "$1" &&
296 git tag "$1"
299 # Call test_merge with the arguments "<message> <commit>", where <commit>
300 # can be a tag pointing to the commit-to-merge.
302 test_merge () {
303 test_tick &&
304 git merge -m "$1" "$2" &&
305 git tag "$1"
308 # This function helps systems where core.filemode=false is set.
309 # Use it instead of plain 'chmod +x' to set or unset the executable bit
310 # of a file in the working directory and add it to the index.
312 test_chmod () {
313 chmod "$@" &&
314 git update-index --add "--chmod=$@"
317 # Use test_set_prereq to tell that a particular prerequisite is available.
318 # The prerequisite can later be checked for in two ways:
320 # - Explicitly using test_have_prereq.
322 # - Implicitly by specifying the prerequisite tag in the calls to
323 # test_expect_{success,failure,code}.
325 # The single parameter is the prerequisite tag (a simple word, in all
326 # capital letters by convention).
328 test_set_prereq () {
329 satisfied="$satisfied$1 "
331 satisfied=" "
333 test_have_prereq () {
334 # prerequisites can be concatenated with ','
335 save_IFS=$IFS
336 IFS=,
337 set -- $*
338 IFS=$save_IFS
340 total_prereq=0
341 ok_prereq=0
342 missing_prereq=
344 for prerequisite
346 total_prereq=$(($total_prereq + 1))
347 case $satisfied in
348 *" $prerequisite "*)
349 ok_prereq=$(($ok_prereq + 1))
352 # Keep a list of missing prerequisites
353 if test -z "$missing_prereq"
354 then
355 missing_prereq=$prerequisite
356 else
357 missing_prereq="$prerequisite,$missing_prereq"
359 esac
360 done
362 test $total_prereq = $ok_prereq
365 # You are not expected to call test_ok_ and test_failure_ directly, use
366 # the text_expect_* functions instead.
368 test_ok_ () {
369 test_success=$(($test_success + 1))
370 say_color "" "ok $test_count - $@"
373 test_failure_ () {
374 test_failure=$(($test_failure + 1))
375 say_color error "not ok - $test_count $1"
376 shift
377 echo "$@" | sed -e 's/^/# /'
378 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
381 test_known_broken_ok_ () {
382 test_fixed=$(($test_fixed+1))
383 say_color "" "ok $test_count - $@ # TODO known breakage"
386 test_known_broken_failure_ () {
387 test_broken=$(($test_broken+1))
388 say_color skip "not ok $test_count - $@ # TODO known breakage"
391 test_debug () {
392 test "$debug" = "" || eval "$1"
395 test_run_ () {
396 test_cleanup=:
397 eval >&3 2>&4 "$1"
398 eval_ret=$?
399 eval >&3 2>&4 "$test_cleanup"
400 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
401 echo ""
403 return 0
406 test_skip () {
407 test_count=$(($test_count+1))
408 to_skip=
409 for skp in $GIT_SKIP_TESTS
411 case $this_test.$test_count in
412 $skp)
413 to_skip=t
414 break
415 esac
416 done
417 if test -z "$to_skip" && test -n "$prereq" &&
418 ! test_have_prereq "$prereq"
419 then
420 to_skip=t
422 case "$to_skip" in
424 say_color skip >&3 "skipping test: $@"
425 say_color skip "ok $test_count # skip $1 (missing $missing_prereq of $prereq)"
426 : true
429 false
431 esac
434 test_expect_failure () {
435 test "$#" = 3 && { prereq=$1; shift; } || prereq=
436 test "$#" = 2 ||
437 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
438 if ! test_skip "$@"
439 then
440 say >&3 "checking known breakage: $2"
441 test_run_ "$2"
442 if [ "$?" = 0 -a "$eval_ret" = 0 ]
443 then
444 test_known_broken_ok_ "$1"
445 else
446 test_known_broken_failure_ "$1"
449 echo >&3 ""
452 test_expect_success () {
453 test "$#" = 3 && { prereq=$1; shift; } || prereq=
454 test "$#" = 2 ||
455 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
456 if ! test_skip "$@"
457 then
458 say >&3 "expecting success: $2"
459 test_run_ "$2"
460 if [ "$?" = 0 -a "$eval_ret" = 0 ]
461 then
462 test_ok_ "$1"
463 else
464 test_failure_ "$@"
467 echo >&3 ""
470 test_expect_code () {
471 test "$#" = 4 && { prereq=$1; shift; } || prereq=
472 test "$#" = 3 ||
473 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
474 if ! test_skip "$@"
475 then
476 say >&3 "expecting exit code $1: $3"
477 test_run_ "$3"
478 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
479 then
480 test_ok_ "$2"
481 else
482 test_failure_ "$@"
485 echo >&3 ""
488 # test_external runs external test scripts that provide continuous
489 # test output about their progress, and succeeds/fails on
490 # zero/non-zero exit code. It outputs the test output on stdout even
491 # in non-verbose mode, and announces the external script with "# run
492 # <n>: ..." before running it. When providing relative paths, keep in
493 # mind that all scripts run in "trash directory".
494 # Usage: test_external description command arguments...
495 # Example: test_external 'Perl API' perl ../path/to/test.pl
496 test_external () {
497 test "$#" = 4 && { prereq=$1; shift; } || prereq=
498 test "$#" = 3 ||
499 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
500 descr="$1"
501 shift
502 if ! test_skip "$descr" "$@"
503 then
504 # Announce the script to reduce confusion about the
505 # test output that follows.
506 say_color "" "# run $test_count: $descr ($*)"
507 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
508 # to be able to use them in script
509 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
510 # Run command; redirect its stderr to &4 as in
511 # test_run_, but keep its stdout on our stdout even in
512 # non-verbose mode.
513 "$@" 2>&4
514 if [ "$?" = 0 ]
515 then
516 if test $test_external_has_tap -eq 0; then
517 test_ok_ "$descr"
518 else
519 say_color "" "# test_external test $descr was ok"
520 test_success=$(($test_success + 1))
522 else
523 if test $test_external_has_tap -eq 0; then
524 test_failure_ "$descr" "$@"
525 else
526 say_color error "# test_external test $descr failed: $@"
527 test_failure=$(($test_failure + 1))
533 # Like test_external, but in addition tests that the command generated
534 # no output on stderr.
535 test_external_without_stderr () {
536 # The temporary file has no (and must have no) security
537 # implications.
538 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
539 stderr="$tmp/git-external-stderr.$$.tmp"
540 test_external "$@" 4> "$stderr"
541 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
542 descr="no stderr: $1"
543 shift
544 say >&3 "# expecting no stderr from previous command"
545 if [ ! -s "$stderr" ]; then
546 rm "$stderr"
548 if test $test_external_has_tap -eq 0; then
549 test_ok_ "$descr"
550 else
551 say_color "" "# test_external_without_stderr test $descr was ok"
552 test_success=$(($test_success + 1))
554 else
555 if [ "$verbose" = t ]; then
556 output=`echo; echo "# Stderr is:"; cat "$stderr"`
557 else
558 output=
560 # rm first in case test_failure exits.
561 rm "$stderr"
562 if test $test_external_has_tap -eq 0; then
563 test_failure_ "$descr" "$@" "$output"
564 else
565 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
566 test_failure=$(($test_failure + 1))
571 # debugging-friendly alternatives to "test [-f|-d|-e]"
572 # The commands test the existence or non-existence of $1. $2 can be
573 # given to provide a more precise diagnosis.
574 test_path_is_file () {
575 if ! [ -f "$1" ]
576 then
577 echo "File $1 doesn't exist. $*"
578 false
582 test_path_is_dir () {
583 if ! [ -d "$1" ]
584 then
585 echo "Directory $1 doesn't exist. $*"
586 false
590 test_path_is_missing () {
591 if [ -e "$1" ]
592 then
593 echo "Path exists:"
594 ls -ld "$1"
595 if [ $# -ge 1 ]; then
596 echo "$*"
598 false
603 # This is not among top-level (test_expect_success | test_expect_failure)
604 # but is a prefix that can be used in the test script, like:
606 # test_expect_success 'complain and die' '
607 # do something &&
608 # do something else &&
609 # test_must_fail git checkout ../outerspace
612 # Writing this as "! git checkout ../outerspace" is wrong, because
613 # the failure could be due to a segv. We want a controlled failure.
615 test_must_fail () {
616 "$@"
617 test $? -gt 0 -a $? -le 129 -o $? -gt 192
620 # Similar to test_must_fail, but tolerates success, too. This is
621 # meant to be used in contexts like:
623 # test_expect_success 'some command works without configuration' '
624 # test_might_fail git config --unset all.configuration &&
625 # do something
628 # Writing "git config --unset all.configuration || :" would be wrong,
629 # because we want to notice if it fails due to segv.
631 test_might_fail () {
632 "$@"
633 test $? -ge 0 -a $? -le 129 -o $? -gt 192
636 # test_cmp is a helper function to compare actual and expected output.
637 # You can use it like:
639 # test_expect_success 'foo works' '
640 # echo expected >expected &&
641 # foo >actual &&
642 # test_cmp expected actual
645 # This could be written as either "cmp" or "diff -u", but:
646 # - cmp's output is not nearly as easy to read as diff -u
647 # - not all diff versions understand "-u"
649 test_cmp() {
650 $GIT_TEST_CMP "$@"
653 # This function can be used to schedule some commands to be run
654 # unconditionally at the end of the test to restore sanity:
656 # test_expect_success 'test core.capslock' '
657 # git config core.capslock true &&
658 # test_when_finished "git config --unset core.capslock" &&
659 # hello world
662 # That would be roughly equivalent to
664 # test_expect_success 'test core.capslock' '
665 # git config core.capslock true &&
666 # hello world
667 # git config --unset core.capslock
670 # except that the greeting and config --unset must both succeed for
671 # the test to pass.
673 test_when_finished () {
674 test_cleanup="{ $*
675 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
678 # Most tests can use the created repository, but some may need to create more.
679 # Usage: test_create_repo <directory>
680 test_create_repo () {
681 test "$#" = 1 ||
682 error "bug in the test script: not 1 parameter to test-create-repo"
683 owd=`pwd`
684 repo="$1"
685 mkdir -p "$repo"
686 cd "$repo" || error "Cannot setup test environment"
687 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
688 error "cannot run git init -- have you built things yet?"
689 mv .git/hooks .git/hooks-disabled
690 cd "$owd"
693 test_done () {
694 GIT_EXIT_OK=t
696 if test -z "$HARNESS_ACTIVE"; then
697 test_results_dir="$TEST_DIRECTORY/test-results"
698 mkdir -p "$test_results_dir"
699 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
701 echo "total $test_count" >> $test_results_path
702 echo "success $test_success" >> $test_results_path
703 echo "fixed $test_fixed" >> $test_results_path
704 echo "broken $test_broken" >> $test_results_path
705 echo "failed $test_failure" >> $test_results_path
706 echo "" >> $test_results_path
709 if test "$test_fixed" != 0
710 then
711 say_color pass "# fixed $test_fixed known breakage(s)"
713 if test "$test_broken" != 0
714 then
715 say_color error "# still have $test_broken known breakage(s)"
716 msg="remaining $(($test_count-$test_broken)) test(s)"
717 else
718 msg="$test_count test(s)"
720 case "$test_failure" in
722 # Maybe print SKIP message
723 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
725 if test $test_external_has_tap -eq 0; then
726 say_color pass "# passed all $msg"
727 say "1..$test_count$skip_all"
730 test -d "$remove_trash" &&
731 cd "$(dirname "$remove_trash")" &&
732 rm -rf "$(basename "$remove_trash")"
734 exit 0 ;;
737 if test $test_external_has_tap -eq 0; then
738 say_color error "# failed $test_failure among $msg"
739 say "1..$test_count"
742 exit 1 ;;
744 esac
747 # Test the binaries we have just built. The tests are kept in
748 # t/ subdirectory and are run in 'trash directory' subdirectory.
749 TEST_DIRECTORY=$(pwd)
750 if test -n "$valgrind"
751 then
752 make_symlink () {
753 test -h "$2" &&
754 test "$1" = "$(readlink "$2")" || {
755 # be super paranoid
756 if mkdir "$2".lock
757 then
758 rm -f "$2" &&
759 ln -s "$1" "$2" &&
760 rm -r "$2".lock
761 else
762 while test -d "$2".lock
764 say "Waiting for lock on $2."
765 sleep 1
766 done
771 make_valgrind_symlink () {
772 # handle only executables
773 test -x "$1" || return
775 base=$(basename "$1")
776 symlink_target=$TEST_DIRECTORY/../$base
777 # do not override scripts
778 if test -x "$symlink_target" &&
779 test ! -d "$symlink_target" &&
780 test "#!" != "$(head -c 2 < "$symlink_target")"
781 then
782 symlink_target=../valgrind.sh
784 case "$base" in
785 *.sh|*.perl)
786 symlink_target=../unprocessed-script
787 esac
788 # create the link, or replace it if it is out of date
789 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
792 # override all git executables in TEST_DIRECTORY/..
793 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
794 mkdir -p "$GIT_VALGRIND"/bin
795 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
797 make_valgrind_symlink $file
798 done
799 OLDIFS=$IFS
800 IFS=:
801 for path in $PATH
803 ls "$path"/git-* 2> /dev/null |
804 while read file
806 make_valgrind_symlink "$file"
807 done
808 done
809 IFS=$OLDIFS
810 PATH=$GIT_VALGRIND/bin:$PATH
811 GIT_EXEC_PATH=$GIT_VALGRIND/bin
812 export GIT_VALGRIND
813 elif test -n "$GIT_TEST_INSTALLED" ; then
814 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
815 error "Cannot run git from $GIT_TEST_INSTALLED."
816 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
817 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
818 else # normal case, use ../bin-wrappers only unless $with_dashes:
819 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
820 if ! test -x "$git_bin_dir/git" ; then
821 if test -z "$with_dashes" ; then
822 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
824 with_dashes=t
826 PATH="$git_bin_dir:$PATH"
827 GIT_EXEC_PATH=$TEST_DIRECTORY/..
828 if test -n "$with_dashes" ; then
829 PATH="$TEST_DIRECTORY/..:$PATH"
832 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
833 unset GIT_CONFIG
834 GIT_CONFIG_NOSYSTEM=1
835 GIT_CONFIG_NOGLOBAL=1
836 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
838 . ../GIT-BUILD-OPTIONS
840 if test -z "$GIT_TEST_CMP"
841 then
842 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
843 then
844 GIT_TEST_CMP="$DIFF -c"
845 else
846 GIT_TEST_CMP="$DIFF -u"
850 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
851 export GITPERLLIB
852 test -d ../templates/blt || {
853 error "You haven't built things yet, have you?"
856 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
857 then
858 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
859 export GITPYTHONLIB
860 test -d ../git_remote_helpers/build || {
861 error "You haven't built git_remote_helpers yet, have you?"
865 if ! test -x ../test-chmtime; then
866 echo >&2 'You need to build test-chmtime:'
867 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
868 exit 1
871 # Test repository
872 test="trash directory.$(basename "$0" .sh)"
873 test -n "$root" && test="$root/$test"
874 case "$test" in
875 /*) TRASH_DIRECTORY="$test" ;;
876 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
877 esac
878 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
879 rm -fr "$test" || {
880 GIT_EXIT_OK=t
881 echo >&5 "FATAL: Cannot prepare test area"
882 exit 1
885 test_create_repo "$test"
886 # Use -P to resolve symlinks in our working directory so that the cwd
887 # in subprocesses like git equals our $PWD (for pathname comparisons).
888 cd -P "$test" || exit 1
890 this_test=${0##*/}
891 this_test=${this_test%%-*}
892 for skp in $GIT_SKIP_TESTS
894 case "$this_test" in
895 $skp)
896 say_color skip >&3 "skipping test $this_test altogether"
897 skip_all="skip all tests in $this_test"
898 test_done
899 esac
900 done
902 # Provide an implementation of the 'yes' utility
903 yes () {
904 if test $# = 0
905 then
907 else
908 y="$*"
911 while echo "$y"
914 done
917 # Fix some commands on Windows
918 case $(uname -s) in
919 *MINGW*)
920 # Windows has its own (incompatible) sort and find
921 sort () {
922 /usr/bin/sort "$@"
924 find () {
925 /usr/bin/find "$@"
927 sum () {
928 md5sum "$@"
930 # git sees Windows-style pwd
931 pwd () {
932 builtin pwd -W
934 # no POSIX permissions
935 # backslashes in pathspec are converted to '/'
936 # exec does not inherit the PID
939 test_set_prereq POSIXPERM
940 test_set_prereq BSLASHPSPEC
941 test_set_prereq EXECKEEPSPID
943 esac
945 test -z "$NO_PERL" && test_set_prereq PERL
946 test -z "$NO_PYTHON" && test_set_prereq PYTHON
948 # test whether the filesystem supports symbolic links
949 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
950 rm -f y
952 # When the tests are run as root, permission tests will report that
953 # things are writable when they shouldn't be.
954 test -w / || test_set_prereq SANITY